SystemOrganization addCategory: #'Mason-Cwp'!

MDProduct subclass: #MDCwpProduct
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mason-Cwp'!

!MDCwpProduct methodsFor: 'paths' stamp: 'cwp 9/17/2009 10:40'!
baseImagePath
	^ self libraryPath 
		/ 'base' 
		/ 'Squeak3.10.2-Trunk-090912' 
		/ 'Squeak3.10.2-trunk.image'! !

!MDCwpProduct methodsFor: 'paths' stamp: 'cwp 9/17/2009 10:42'!
libraryPath
	^ FSDiskFilesystem root / 'Users' / 'colin' / 'Library' / 'Squeak'! !

!MDCwpProduct methodsFor: 'paths' stamp: 'cwp 9/17/2009 10:43'!
masonRepositoryPath
	^ FSDiskFilesystem root / 'Users' / 'colin' / 'Projects' / 'Mason' / 'mason.mcr'! !

!MDCwpProduct methodsFor: 'paths' stamp: 'cwp 7/14/2009 00:31'!
repositoryPath
	^ self libraryPath / 'package-cache'! !

!MDCwpProduct methodsFor: 'paths' stamp: 'cwp 7/13/2009 15:05'!
scriptsPath
	^ self libraryPath / 'scripts'! !

MDCwpProduct subclass: #MDIdeProduct
	instanceVariableNames: 'packages'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mason-Cwp'!

!MDIdeProduct methodsFor: 'specifying' stamp: 'cwp 9/17/2009 23:37'!
customizer: packageNames
	^ 
		[:names |
		packageNames collect:
			[:packageName | 
			names 
				detect: [:versionName | versionName beginsWith: packageName]
				ifNone: [self error: packageName, 'not found']]]! !

!MDIdeProduct methodsFor: 'ext deps' stamp: 'cwp 9/17/2009 23:40'!
edPackageNames
	^ #(
		'AST'
		'Refactoring-Core'
		'Refactoring-Spelling'
		'VB-Regex'
	)! !

!MDIdeProduct methodsFor: 'ext deps' stamp: 'cwp 9/17/2009 23:39'!
extDeps
	^ MDUmbrellaProduct new
		repository: self repository;
		packageName: 'OB-ExtDeps';
		customizeWith: (self customizer: self edPackageNames);
		yourself! !

!MDIdeProduct methodsFor: 'initialize-release' stamp: 'cwp 7/12/2009 04:51'!
initialize
	packages := '/Users/colin/Library/Squeak/package-cache' asPath.
! !

!MDIdeProduct methodsFor: 'omnibrowser' stamp: 'cwp 9/17/2009 23:33'!
obPackageNames
	^ #(
		'OmniBrowser'
		'OB-Morphic'
		'OB-Standard'
		'OB-Refactory'
		'OB-Regex'
		'OB-Shout'
		'OB-SUnitIntegration'
	)! !

!MDIdeProduct methodsFor: 'specifying' stamp: 'cwp 9/17/2009 23:38'!
repository
	^ MCHttpRepository
		location: 'http://source.wiresong.ca/ob/'
		user: ''
		password: ''! !

!MDIdeProduct methodsFor: 'specifying' stamp: 'cwp 9/17/2009 23:34'!
specifyOn: targets
	targets image
		name: 'ide';
		baseImage: self baseImagePath;
		with: 
			[targets specify: self extDeps.
			targets specify: self umbrella]! !

!MDIdeProduct methodsFor: 'omnibrowser' stamp: 'cwp 9/17/2009 23:38'!
umbrella
	^ MDUmbrellaProduct new
		repository: self repository;
		packageName: 'OB-Umbrella';
		customizeWith: (self customizer: self obPackageNames);
		yourself! !

MDCwpProduct subclass: #MDMc2DevProduct
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mason-Cwp'!

!MDMc2DevProduct methodsFor: 'paths' stamp: 'cwp 7/12/2009 05:08'!
mc2ReleasePath
	^ FSPath root
		/ 'Users'
		/ 'colin'
		/ 'Projects'
		/ 'Monticello2'
		/ 'releases'
		/ 'Monticello-2.0.31'! !

!MDMc2DevProduct methodsFor: 'specifying' stamp: 'cwp 8/8/2009 10:51'!
specifyOn: targets 
	targets directory
		path: 'development';
		with: 
			[ targets image
				name: 'ide';
				baseImage: self baseImagePath;
				with: 
					[ targets script path: self scriptsPath / 'remove-mc1.st'.
					targets script path: self scriptsPath / 'base-image-cleanup-3.10.cs'.
					targets specify: MDIdeProduct.
					targets script path: self mc2ReleasePath / '1-Monticello2.st'] ]! !

MDCwpProduct subclass: #MDMc2DistProduct
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mason-Cwp'!

!MDMc2DistProduct methodsFor: 'as yet unclassified' stamp: 'cwp 7/12/2009 05:20'!
devPath
	^ FSPath root
		/ 'Users'
		/ 'colin'
		/ 'Projects'
		/ 'Monticello2'
		! !

!MDMc2DistProduct methodsFor: 'as yet unclassified' stamp: 'cwp 7/13/2009 18:32'!
specifyOn: targets
	targets directory path: self versionString; with:
		[targets file
			path: self devPath / 'mc.mcr';
			jobClass: MDCopyFileJob.
		targets directory path: 'extras'; with: 
			[targets file
				path: self scriptsPath / 'remove-mc1.st';
				jobClass: MDCopyFileJob.
			targets file
				path: self scriptsPath / 'remove-mc2.st';
				jobClass: MDCopyFileJob].
		targets directory path: 'docs'; with:
			[targets files
				directoryPath: self devPath / 'docs';
				pattern: '*.creole';
				jobClass: MDRenderCreoleJob.
			targets file
				path: self devPath / 'docs' / 'docs.css';
				jobClass: MDCopyFileJob.
			targets directory path: 'images'; with:
				[targets files
					directoryPath: self devPath / 'docs' / 'images';
					pattern: '*.png';
					jobClass: MDCopyFileJob]]]! !

!MDMc2DistProduct methodsFor: 'as yet unclassified' stamp: 'cwp 7/13/2009 18:29'!
versionString
	^ 'Monticello-2.0.30'! !

MDCwpProduct subclass: #MDOBDevProduct
	instanceVariableNames: 'packages'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mason-Cwp'!

!MDOBDevProduct methodsFor: 'as yet unclassified' stamp: 'cwp 7/13/2009 15:12'!
initialize
	packages := self libraryPath / 'package-cache'! !

!MDOBDevProduct methodsFor: 'as yet unclassified' stamp: 'cwp 7/13/2009 15:06'!
specifyOn: targets
	targets directory path: 'development'; with:
		[targets image
			name: 'ide'; 
			baseImage: self baseImagePath;
			with: [targets specify: MDIdeProduct].
		targets image
			name: 'tests';
			baseImage: 'ide';
			with:
				[targets mc1 path: packages / 'Bogus-cwp.18.mcz'.
				targets mc1 path: packages / 'BogusExt-cwp.3.mcz'.
				targets mc1 path: packages / 'BogusInfo-cwp.17.mcz'.
				targets mc1 path: packages / 'OB-Fake-lr.9.mcz'.
				targets mc1 path: packages / 'OB-Tests-Core-cwp.65.mcz'.
				targets mc1 path: packages / 'OB-Tests-Morphic-cwp.16.mcz'.
				targets mc1 path: packages / 'OB-Tests-Standard-cwp.85.mcz'].
		targets tests 
			name: 'testrun';
			imagePath: 'tests';
			with: [targets suite package: 'OB-Tests']]
! !

MDCwpProduct subclass: #MDOBDistProduct
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mason-Cwp'!

!MDOBDistProduct methodsFor: 'accessing' stamp: 'cwp 8/3/2009 09:00'!
devDirectory
	^ FSPath / 'Users' / 'colin' / 'Projects' / 'OmniBrowser'! !

!MDOBDistProduct methodsFor: 'accessing' stamp: 'cwp 9/1/2009 22:21'!
mczFilenames
	^#(
		'OmniBrowser-cwp.453' 
		'OB-Morphic-cwp.100' 
		'OB-Standard-cwp.428'
		'OB-Shout-cwp.1'
		
		'AST-Gwenael_Casaccio.215'
		'Refactoring-Core-lr.57'
		'Refactoring-Spelling-lr.6'
		'VB-Regex-damienpollet.17'
		'OB-Refactory-lr.159'
		'OB-Regex-lr.19'
		
		'OB-SUnitIntegration-lr.14'
	)! !

!MDOBDistProduct methodsFor: 'paths' stamp: 'cwp 7/14/2009 00:54'!
pathForVersionName: name 
	^ self repositoryPath / (name , '.mcz')! !

!MDOBDistProduct methodsFor: 'accessing' stamp: 'cwp 7/14/2009 01:01'!
scriptName: name index: index 
	^ String streamContents:
		[:out |
		index printOn: out base: 10 length: 2 padded: true.
		out nextPut: $-;
			nextPutAll: (name copyUpToLast: $-);
			nextPutAll: '.st']
	! !

!MDOBDistProduct methodsFor: 'specifying' stamp: 'cwp 8/27/2009 22:18'!
specifyDocsOn: targets 
	targets file
		jobClass: MDCopyFileJob new;
		path: self devDirectory / 'build' / 'README.txt'.
		
	targets file
		jobClass: MDCopyFileJob new;
		path: self devDirectory / 'build' / 'ReleaseNotes.txt'! !

!MDOBDistProduct methodsFor: 'specifying' stamp: 'cwp 8/3/2009 08:47'!
specifyFileoutsOn: targets 
	^ self mczFilenames withIndexDo: 
		[ :name :index | 
		targets mczFileout
			path: (self pathForVersionName: name);
			name: (self 
					scriptName: name
					index: index) ]! !

!MDOBDistProduct methodsFor: 'specifying' stamp: 'cwp 8/3/2009 08:48'!
specifyOn: targets 
	targets directory
		path: self versionString;
		with: 
			[self specifyDocsOn: targets.
			self specifyFileoutsOn: targets]! !

!MDOBDistProduct methodsFor: 'accessing' stamp: 'cwp 8/27/2009 21:58'!
versionString
	^ 'OmniBrowser-2.0.3'! !
